<?xml version="1.0"?>

<!-- This style sheet takes a sourceforge artifact in html and outputs
     the attachment descriptions that it finds. The output is as follows:
     <attachments>
       <attachment>
         <attachid>###</attachid>
	 <desc>...</desc>
       </attachment>
       ...
     </attachments>
-->

<xsl:stylesheet version="1.0"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns:xhtml="http://www.w3.org/1999/xhtml"
		exclude-result-prefixes="xhtml">

<xsl:template match="xhtml:tr" mode="download">
  <attachment>
    <attachid>
      <xsl:value-of select="substring-before(substring-after(xhtml:td[4]/descendant::xhtml:a/@href,'file_id='),'&amp;')"/>
    </attachid>
    <desc>
      <xsl:value-of select="normalize-space(xhtml:td[3])"/>
    </desc>
  </attachment>
</xsl:template>

<xsl:template match="xhtml:table[preceding-sibling::xhtml:h4='Attached Files:' and xhtml:tr/xhtml:td='Download']">
    <xsl:for-each select="xhtml:tr[descendant::xhtml:a='Download']">
      <xsl:apply-templates select="." mode="download"/>
    </xsl:for-each>
</xsl:template>

<xsl:template match="/">
  <attachments>
    <xsl:apply-templates/>
    <!-- A null description used as a fallback for when there is no
         description listed for an attachment. -->
    <desc xml:id="null"/>
  </attachments>
</xsl:template>

<xsl:template match="node()" priority="-1">
  <xsl:apply-templates/>
</xsl:template>

<xsl:template match="text()" priority="-1"></xsl:template>

</xsl:stylesheet>
