<?xml version="1.0"?>

<!-- This style sheet takes the output of xml_attached file (which represents
     an attachment and it's MIME type), adds in the following extra nodes:
       date, desc & filename.
-->

<xsl:stylesheet version="1.0"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns:xi="http://www.w3.org/2001/XInclude">

<xsl:template match="attachment">
  <xsl:copy>
    <xsl:for-each select="@*">
      <xsl:copy/>
    </xsl:for-each>
    <xsl:apply-templates/>
    <xsl:element namespace="http://www.w3.org/2001/XInclude" name="include">
      <xsl:attribute name="href">
	<xsl:text>attachment-details.xml</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="xpointer">
	<xsl:text>xpointer(/attachments/attachment[attachid='</xsl:text>
	<xsl:value-of select="attachid"/>
	<xsl:text>']/*)</xsl:text>
      </xsl:attribute>
    </xsl:element>
    <xsl:element namespace="http://www.w3.org/2001/XInclude" name="include">          <xsl:attribute name="href">
	<xsl:text>attachment-descriptions.xml</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="xpointer">
	<xsl:text>xpointer(/attachments/attachment[attachid='</xsl:text>
	<xsl:value-of select="attachid"/>
	<xsl:text>']/desc)element(null)</xsl:text>
      </xsl:attribute>
    </xsl:element>
  </xsl:copy>
</xsl:template>

<!-- Drop the attachment ID to avoid duplication with the node included
     from attachment-details.xml -->

<xsl:template match="attachid"/>

<xsl:template match="*">
  <xsl:copy>
    <xsl:for-each select="@*">
      <xsl:copy/>
    </xsl:for-each>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

</xsl:stylesheet>
