<?xml version="1.0"?>

<!-- A set of templates used in multiple stylesheets -->

<xsl:stylesheet version="1.0"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns:date="http://exslt.org/dates-and-times"
		extension-element-prefixes="date">

<!-- Convert a UNIX-style date (seconds since 1 Jan 1970) to
     the timestamp format used by bugzilla: %Y-%m-%d %X -->
<xsl:template name="bugzilla-timestamp">
  <xsl:param name="secs" select="."/>
  <xsl:variable name="dt" select="date:add('1970',concat('PT',$secs,'S'))"/>
  <xsl:value-of select="date:year($dt)"/>
  <xsl:text>-</xsl:text>
  <xsl:value-of select="format-number(date:month-in-year($dt),'00')"/>
  <xsl:text>-</xsl:text>
  <xsl:value-of select="format-number(date:day-in-month($dt),'00')"/>
  <xsl:text> </xsl:text>
  <xsl:value-of select="format-number(date:hour-in-day($dt),'00')"/>
  <xsl:text>:</xsl:text>
  <xsl:value-of select="format-number(date:minute-in-hour($dt),'00')"/>
  <xsl:text>:</xsl:text>
  <xsl:value-of select="format-number(date:second-in-minute($dt),'00')"/>
  <xsl:text> UTC</xsl:text>
</xsl:template>

</xsl:stylesheet>
