<?xml version="1.0"?>

<xsl:stylesheet version="1.0"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns:xhtml="http://www.w3.org/1999/xhtml"
		xmlns:exsl="http://exslt.org/common"
		extension-element-prefixes="exsl"
		exclude-result-prefixes="xhtml">

<xsl:variable name="users">
  <xsl:for-each select="//users/user">
    <user>
      <xsl:copy-of select="@name"/>
      <xsl:value-of select="."/>
    </user>
  </xsl:for-each>
  <xsl:for-each select="//xhtml:td[xhtml:b='Submitted By:' and xhtml:a]">
    <xsl:element name="user">
      <xsl:attribute name="name">
	<xsl:for-each select="text()">
	  <xsl:if test="contains(., '-')">
	    <xsl:value-of select="normalize-space(substring-before(., '-'))"/>
	  </xsl:if>
	</xsl:for-each>
      </xsl:attribute>
      <xsl:value-of select="xhtml:a"/>
      <xsl:text>@users.sourceforge.net</xsl:text>
    </xsl:element>
  </xsl:for-each>
  <xsl:for-each select="//xhtml:table[xhtml:tr/xhtml:td[normalize-space(.)='Login Name:'] and xhtml:tr/xhtml:td[normalize-space(.)='Publicly Displayed Name:']]">
    <xsl:element name="user">
      <xsl:attribute name="name">
	<xsl:value-of select="normalize-space(xhtml:tr/xhtml:td[normalize-space(.)='Publicly Displayed Name:']/following-sibling::xhtml:td)"/>
      </xsl:attribute>
	<xsl:value-of select="normalize-space(xhtml:tr/xhtml:td[normalize-space(.)='Login Name:']/following-sibling::xhtml:td)"/>
      <xsl:text>@users.sourceforge.net</xsl:text>
    </xsl:element>
  </xsl:for-each>
</xsl:variable>

<xsl:variable name="sorted_users">
  <xsl:for-each select="exsl:node-set($users)/user">
    <xsl:sort/>
    <xsl:copy-of select="."/>
  </xsl:for-each>
</xsl:variable>

<xsl:template match="/">
  <users>
    <xsl:for-each select="exsl:node-set($sorted_users)/user">
      <xsl:if test="not(. = following-sibling::user[1])">
	<xsl:copy>
	  <xsl:copy-of select="@name"/>
	  <xsl:value-of select="."/>
	</xsl:copy>
      </xsl:if>
    </xsl:for-each>
  </users>
</xsl:template>

</xsl:stylesheet>
